// RewriteFilter.cpp - Implementation file for ISAPI
//    RewriteFilter Filter

#include "stdafx.h"
#include "RewriteFilter.h"
#include <string>

/* Maximum length of a URI */
#define MAX_URI_SIZE 4065

// The one and only CWinApp object
// NOTE: You may remove this object if you alter your project to no
// longer use MFC in a DLL.

CWinApp theApp;




// The one and only CRewriteFilterFilter object

CRewriteFilterFilter theFilter;



// CRewriteFilterFilter implementation

CRewriteFilterFilter::CRewriteFilterFilter()
{
}

CRewriteFilterFilter::~CRewriteFilterFilter()
{
}

BOOL CRewriteFilterFilter::GetFilterVersion(PHTTP_FILTER_VERSION pVer)
{
	// Call default implementation for initialization
	CHttpFilter::GetFilterVersion(pVer);

	// Clear the flags set by base class
	pVer->dwFlags &= ~SF_NOTIFY_ORDER_MASK;

	// Set the flags we are interested in
	pVer->dwFlags |= SF_NOTIFY_SECURE_PORT | SF_NOTIFY_NONSECURE_PORT | SF_NOTIFY_PREPROC_HEADERS | SF_NOTIFY_END_OF_NET_SESSION;

	// Set Priority
	pVer->dwFlags |= SF_NOTIFY_ORDER_HIGH;

	// Load description string
	TCHAR sz[SF_MAX_FILTER_DESC_LEN+1];
	ISAPIVERIFY(::LoadString(AfxGetResourceHandle(),
			IDS_FILTER, sz, SF_MAX_FILTER_DESC_LEN));
	_tcscpy(pVer->lpszFilterDesc, sz);
	return TRUE;
}

DWORD CRewriteFilterFilter::OnPreprocHeaders(CHttpFilterContext* pCtxt,
	PHTTP_FILTER_PREPROC_HEADERS pHeaderInfo)
{
	// TODO: React to this notification accordingly and
	// return the appropriate status code

	/* Let the web server allocate (MAX_URI_SIZE+1) bytes of memory for us */
	char buffer[MAX_URI_SIZE];
	DWORD bufferSize = MAX_URI_SIZE;

	/* Copy the header 'url' to the address (CurrentURI+1) */
	if( !pHeaderInfo->GetHeader(pCtxt->m_pFC, "url", buffer, &bufferSize) ) {
		/* The URI was not fetched successfully */
		return SF_STATUS_REQ_ERROR;
	}

	CString urlString(buffer);
	
	if (urlString.Find("/w_/") != -1) //we want to redirect this file
    {
		//Log("Orginal:" + urlString);
		//urlString.Replace(".tx",".txt");
		
		int fileNameStart = urlString.ReverseFind('/');
		CString fileName = urlString.Right(strlen(urlString) - fileNameStart);
		//Log("fileName:" + fileName);
		
		int paramStart = urlString.Find("/w_/") + 4;
		
		bool equalChar = true;
		//CString params = "";
		CString params = "";
		for(int i = paramStart; i < strlen(urlString) - (strlen(urlString) - fileNameStart); i++) {
			if(urlString[i] == '/') {
				if(equalChar)
					params += '=';
				else
					params += '&';
				equalChar = !equalChar;
			}
			else
				params += urlString[i];
		}
		//Log("params:" + params);
		
		CString fullUrl = urlString.Left(paramStart - 4) + fileName + '?' + params;
		//Log("fullUrl:" + fullUrl);
		
		char *newUrlString = fullUrl.GetBuffer(fullUrl.GetLength());
        pHeaderInfo->SetHeader(pCtxt->m_pFC, "url", newUrlString);
        return SF_STATUS_REQ_HANDLED_NOTIFICATION;
    }


	return SF_STATUS_REQ_NEXT_NOTIFICATION;
}

DWORD CRewriteFilterFilter::OnEndOfNetSession(CHttpFilterContext* pCtxt)
{
	// TODO: React to this notification accordingly and
	// return the appropriate status code
	return SF_STATUS_REQ_NEXT_NOTIFICATION;
}

void CRewriteFilterFilter::Log(CString str) {
//Log here...
	char* pszFileName = "c:\\tmp\\log.txt";
	CFile myFile;
	CFileException fileException;
	
	str += "\n";

	if (myFile.Open( pszFileName, CFile::modeReadWrite, &fileException)) {
		//TRACE( "Can't open file %s, error = %u\n", pszFileName, fileException.m_cause );
		myFile.SeekToEnd();
		myFile.Write( str.GetBuffer(str.GetLength()), str.GetLength() ); 

	}


}
// If your extension will not use MFC, you'll need this code to make
// sure the extension objects can find the resource handle for the
// module.  If you convert your extension to not be dependent on MFC,
// remove the comments around the following AfxGetResourceHandle()
// and DllMain() functions, as well as the g_hInstance global.

/****

static HINSTANCE g_hInstance;

HINSTANCE AFXISAPI AfxGetResourceHandle()
{
	return g_hInstance;
}

BOOL WINAPI DllMain(HINSTANCE hInst, ULONG ulReason,
					LPVOID lpReserved)
{
	if (ulReason == DLL_PROCESS_ATTACH)
	{
		g_hInstance = hInst;
	}

	return TRUE;
}

****/
